/*
 File: wysuwygOverlay.js
 Copyright: Rahul Singh
 Mail: induscrypt@gmail.com
 Source: http://wysuwyg.mozdev.org
 Referenced by: wysuwygOverlay.xul
 Description: The javascript that contains backend code for the overlay
 			Launches the html page containing the main editor
 			Listens for menu and contect meu commands
 			Provides tolerance for immature closing of source window etc.
 			Provides functilonality for dealing with tabs
 Acknowledgements: Functions openXinhaWin  and initOverlay borrow heavily 
 			from Xinha Here! by Jayson Harshbarger at hypercubed.com			

*/



var wyspref_tabenabled=true;
var wyspref_sdbarenabled=true;
var wyspref_histenbled=true;
var wyspref_winontop=true;
var wyspref_referenabled=true;
var wyspref_debugenabled=true;
var wysHelpURL="http://wysuwyg.mozdev.org/wysuwyg_guide.html";
var wysScriptRx=/(<script[\s])|(<[^>]*=["'\s]*[jav]{0,4}script:)/ ; //"



//a class that will hold all the functions
//and data for the Overlay

var WYS_Olay = {
 
 
ta : null,
ta_html : null,
ta_url : null,
ta_doc : null,  //current document
ta_doc_tab : null, //browser tab with current doc 
STL : null, // WYS_TabList
editor_tab:null,
ta_flag:false, //is a textarea focused? also it shouldn't be a browser's TA
	
openXinhaWin : function ()
	{	
	
	this.ta = document.commandDispatcher.focusedElement;
	
	//this.ta_flag = ((this.ta !=null) && (this.ta_url.search(/(^http:\/\/)|(^file:\/\/)/)!=-1) ) ;
	this.ta_flag = ((this.ta !=null) && (this.ta.ownerDocument.URL !=null));
	
	if (this.ta_flag )
	{
	
	if (this.isTxtUnsecure(document.commandDispatcher.focusedElement.value))
		{ 
			this.cleanOverlay();
			return;
		} 
	
	
	this.ta_html = this.ta.value;		
	this.ta_doc = gBrowser.contentDocument;
	this.ta_url = gBrowser.contentDocument.URL;	 
	this.ta_doc_tab=gBrowser.selectedTab ;	
	}
	//nxt 2 lines copied from xinhaHere
	var winontop=wyspref_winontop?'yes':'no';		
	var e_par = "toolbar=no,menubar=no,personalbar=no,width=752,height=640, alwaysRaised="+winontop+"," 
				+"centerscreen=yes ,scrollbars=no,resizable=yes, dependent=no,chrome=no, modal=no" ;	
	var e_win = window.open("chrome://wysuwyg/content/EditorPageWindowed.html", "editor_xul", e_par);	
	if (e_win==null){alert('Sorry! Editor window could not be launched.\nAre you using a pop-up blocker?');return;}
	
	//else
	if (wyspref_histenbled && this.ta_flag )
	wysHistory.saveEntry( this.ta_doc.title,this.ta_url,(new Date()).toLocaleString() );			
	}, 	
	
	//reInventing a Tabbed Wheel	
	
openXinhaTab : function (pagecode)
	{	
	if(!wyspref_tabenabled){alert("Feature Disabled!\n Please Change Preferences for wySUwyg"); return;}
	
	if ((WYS_Olay.STL !=null) && (WYS_TabList.tabcount == WYS_TabList.MAXTABS) )
		{alert("Sorry, no more than "+ WYS_TabList.MAXTABS +" wySUwyg tabs allowed! ");return;}
	
	//this.ta_url=null; //flush url, the event-based system picks old statics!!
	this.ta = document.commandDispatcher.focusedElement;
	
	//this.ta_flag = ((this.ta !=null) && (this.ta_url.search(/(^http:\/\/)|(^file:\/\/)/)!=-1) ) ;
	this.ta_flag = ((this.ta !=null) && (this.ta.ownerDocument.URL !=null));
	if (this.ta_flag)
	{
		if (this.isTxtUnsecure(document.commandDispatcher.focusedElement.value))
		{ 
			this.cleanOverlay();
			return;
		} 
	}
	
	
	//check if user is already editing this document
	var tmpTab = WYS_TabList.findTab1(gBrowser.selectedBrowser,WYS_Olay.STL);
	if (tmpTab != null )
		{	// OK, the 'browser' is same, now check if the source doc is also the same
			// A User might be reusing a source Tab bfefore submitting from ed. Let him
			if (gBrowser.selectedBrowser.contentDocument !=tmpTab.doc)
				{WYS_Olay.STL=WYS_TabList.removeTab(tmpTab,WYS_Olay.STL); }
			else		
				{
				  //alert("You are already editing this document!");
				  var res=confirm("You are already editing this document! \n Click OK to go to editor");
				  if (res) gBrowser.selectedTab =tmpTab.edtab;
				  return;
				  }
		}
	
	if (this.ta_flag)
	 	{
	 	
	 	this.ta_html = this.ta.value;
	 	this.ta_doc = gBrowser.contentDocument;
	 	this.ta_url = gBrowser.contentDocument.URL;	 
	 	this.ta_doc_tab=gBrowser.selectedTab ;
	 	
	 	
	 	}
	
	if ( (pagecode!=null) &&(pagecode==1) )
	 this.editor_tab = gBrowser.addTab("chrome://wysuwyg/content/EditorPage_XinhaFull.html");	
	else
	 this.editor_tab = gBrowser.addTab("chrome://wysuwyg/content/EditorPageTabbed.html");

	
	//events for sending document info to overlay. once these events are fired,
	//  overlay will also append these tabs to tablist (see myTabListener)
	document.addEventListener("WYS_ExtTalkEventSet", this.myTabListener , false );	
	//this.ta_doc.addEventListener("unload", function f(){alert("You're editing a textarea in this page.");} , false );//!
		
	gBrowser.selectedTab =this.editor_tab;	
	if(wyspref_histenbled && this.ta_flag)
	wysHistory.saveEntry( this.ta_doc.title,this.ta_url,(new Date()).toLocaleString() );
		
	},//end function

 
 
 
 // On submitting from the editor, check if the original window->tab->document 
 //is still available (this function is for  Windowed mode only)
checkSourceDoc: function (){
  //check if the tab is still available and still has the same document  
   try{
	   gBrowser.selectedTab=this.ta_doc_tab ;
	   var nowdoc= gBrowser.contentDocument;
	   if (nowdoc!=this.ta_doc) return false;
	   else return true;
	 }catch (ex){return false;} 
  
  },
  
 //Same thing for tabbed mode--it uses static vars because of event mechanism
 //This has to remove tabs from list as well, so let it do everything
 
submitFromTab : function (tst,e){
    
   	try{
   		//first see if it's on the list
   		var tb = WYS_TabList.findTab(tst,WYS_Olay.STL);
   		if (tb==null) return false;
   		
   		//else
   		gBrowser.selectedTab= tb.tab;  //throws up if tab closed, else brings to front
   		var nowdoc= gBrowser.contentDocument;
   		if (nowdoc!=tb.doc)
   		{//now this tab is useless for us
   		gBrowser.selectedTab =tb.edtab ;
   		WYS_Olay.STL=WYS_TabList.removeTab(tb,WYS_Olay.STL) ;
   		tb=null; //destroy useless tab
   		return false;}
   		else
   		{
   		//do the real thing
   		t=tb.tarea;
   		t.value=e.target.getAttribute("att_sourceTAtxt");
   		//e.target.setAttribute("att_success", 1); //rahul-is it still needed?
   		
   		//stop listening, else memleak
   		//this.window.document.removeEventListener("WYS_ExtTalkEventGet", this.myTabListener , false );//at start
		//this.window.document.removeEventListener("WYS_ExtTalkEventSet", this.myTabListener , false );//at end
   		
   		
   		//done? Now close the editor (as the page cannot close itself)
   		gBrowser.removeTab(tb.edtab);
   		
   		return true;}
   	 }catch (ex){ if(wyspref_debugenabled)alert (ex.message);return false;}
  
  },


	//Capture custom event from a page opened in a tab

myTabListener: function (e) {
	// -- TO DO : Check if opened by wySUwyg only -- //
	
	try{
	
	var elem=e.target;
  	var req=elem.getAttribute("att_mode") ; //what is the request? 	
    	
  		//now, set the values for the attributes for that element
  		if (req=='getData')
  		{  	
  			if (!WYS_Olay.ta_flag ) return;
  			
  			//else
  			
  			//ok, this static looking affair is messy, but this=source, so no 'this'
  			elem.setAttribute("att_sourceURL", WYS_Olay.ta_url);
  			elem.setAttribute("att_sourceTAtxt", WYS_Olay.ta_html);
  			
  			//the timestamp is the unique id shared between
  			//the element on the page and the data in the tablist
  			var tstamp=(new Date()).getTime();
  			elem.setAttribute("att_timestamp", tstamp);
  			
  			//now create tabElement for the tablist
  			brEd=gBrowser.getBrowserForTab(WYS_Olay.editor_tab);
  			brSrc=gBrowser.getBrowserForTab(WYS_Olay.ta_doc_tab);
  			tel= new tabEl(WYS_Olay.ta_doc_tab,WYS_Olay.ta_doc,tstamp,WYS_Olay.ta,WYS_Olay.editor_tab,brEd,brSrc);
  			
  			//add this element to tablist
  			WYS_Olay.STL= WYS_TabList.addTab(tel,WYS_Olay.STL); //auto-creates if null list
		 }
  		
  		else if  (req=='setData') //editor is submitting data
  		{
  			var ts=elem.getAttribute("att_timestamp");  		  		
  			if (!WYS_Olay.submitFromTab(ts,e) )
  				{alert('The original TextBox is no more available!\n Please copy your text');}  			
  		} 
		else if  (req=='setDestroyed') //editor page is unloaded/reused by user or closed,
  		{	
  			var ts=elem.getAttribute("att_timestamp");  		  		
  			var tb = WYS_TabList.findTab(ts,WYS_Olay.STL);
			if (tb!=null) 
				{	
					WYS_Olay.STL=WYS_TabList.removeTab(tb,WYS_Olay.STL) ;
					tb=null; 
				}
  		}	

   }catch (ex) {if(wyspref_debugenabled)alert('Error:in myTabListener \n'+ex.message );}
  	   
},


 //not used, just some debug
 helpVal: function()
 {
     return this.ta.value;
 },
  
  
   
//Every time a tab is removed, check if it was an editor or launcher (source)
//if so,remove it from the tablist  
checkRemovedTab : function (event)
  { 
    if (!wyspref_tabenabled)return;
    
    //else
    
  	if (event.relatedNode != gBrowser.mPanelContainer)
		{return; }
  	
  	//var browser = event.target.childNodes[1];  	
  	var browser = event.target.firstChild; //changed, nov 2006
  	var tb= WYS_TabList.findTab1(browser,WYS_Olay.STL);  	
  	if (tb!=null)
  		{
  		WYS_Olay.STL=WYS_TabList.removeTab(tb,WYS_Olay.STL);  	
  		//alert("removed tab, left "+ WYS_TabList.tabcount  );
  		}
  	
  },
  
  
	
initOverlay: function() {
  	var menu = document.getElementById("contentAreaContextMenu");
  	menu.addEventListener("popupshowing", WYS_Olay.contextPopupShowing, false);
  	
  	var container = gBrowser.mPanelContainer;
	container.addEventListener("DOMNodeRemoved", WYS_Olay.checkRemovedTab, false);	
	
	loadPrefs();
	
	
	//init history
	if (wyspref_histenbled) 
		startHist(null,wyspref_debugenabled) ;	
  	
  },
	
	// show context menu only for textarea
	contextPopupShowing: function()
	{
  	gContextMenu.showItem("men_wysuwyg", gContextMenu.onTextInput);
  		
    },  
     
isTxtUnsecure: function (instr)
{
	var res= instr.match(wysScriptRx);	
	if (res !=null) {alert("wySUwyg: Scripts in input are NOT allowed!\nFound:\n'"+res[0]+"'"); return true};
	if (res==null){res =(unescape(instr)).match(wysScriptRx); }
	if (res !=null) {alert("wySUwyg: Scripts in input are NOT allowed!\nFound:\n'"+escape(res[0])+"'"); return true};
	//else
	return false;

},  
  
cleanOverlay: function  ()
{

  try{  
  	this.ta = null;
	this.ta_html = null;
	this.ta_url = null;
	this.ta_doc = null;  
	this.ta_doc_tab = null; 
	this.STL = null; 
	this.editor_tab=null;

	//stop listening, else memleak?
	if (this.window)
		this.window.document.removeEventListener("WYS_ExtTalkEventSet", this.myTabListener , false );
		
   		
   	}catch (ex) {if(wyspref_debugenabled)alert("wySUwyg: Error Cleaning Up Overlay: \n"+ex.message);}	
}


/*
//New Function for in-place editor
openXinhaSub: function ()
{
	this.ta = document.commandDispatcher.focusedElement;
	
	
	this.ta_flag = ((this.ta !=null) && (this.ta.ownerDocument.URL !=null));
	
	if (this.ta_flag )
	{
		var doc=this.ta.ownerDocument;
		var taId=this.ta.id ;	
		var appdir="chrome://wysuwyg/content/";
		var scripts_urls=["test_init.js","xinha/htmlarea.js","autotest_js1.js"];
		var wysres_js_ids=["RES-js0","RES-js1","RES-js2"];
		
		//alert (taId);
		
		for ( i=0;i<3;i++)
		{
			var res_js_id=wysres_js_ids[i];
			var js = doc.getElementById(res_js_id);
			if (js == null) 
				{
					js = doc.createElement("script");
					js.id = res_js_id ;
					js.type='text/javascript';
					js.language = 'javascript';
					if (i!=0)
					js.src = appdir+scripts_urls[i];
					else js.innerHTML="_editor_url  ='"+ appdir+"xinha/'; myTA_ID='"+ taId+"';";
					doc.getElementsByTagName("HEAD")[0].appendChild(js);					
    			}
    	 }//for
    	 
    	 //for now ,add a button to trigger replacement
    	 var bTrigg=doc.createElement("input");
    	 bTrigg.setAttribute( "type", "button");
    	 bTrigg.setAttribute( "id", "wys_bTrigger");    	 
    	 bTrigg.setAttribute( "value", "Launch editor");
    	 bTrigg.setAttribute( "onclick", " xinha_init();return;"); //window.setTimeout('xinha_init()',1000)
    	 doc.getElementsByTagName("BODY")[0].appendChild(bTrigg);    	 
	  }//if	
	// Final Obs: So Near! As expected, isn't allowed to load blank.html. 	
	}  //end openXinhaSub
*/	


	
} //end WYS_Olay






function openSidebar()
{   
	if(!wyspref_sdbarenabled){alert("Feature Disabled!\n Please Change Preferences for wySUwyg"); return;}
	//else
	var url="chrome://wysuwyg/content/wysuwyg_dragdrop.xul";
	var sidebar = document.getElementById('WYS_Sidebar')
	sidebar.setAttribute('sidebarurl',url);
	
	//sidebar.setAttribute('sidebartitle',"WYS_Olay");
	toggleSidebar('WYS_Sidebar');
}


function openPrefWindow()
{

	var prefwin="chrome://wysuwyg/content/wysuwyg_prefwin.xul";
	window.openDialog(prefwin, "wySUwygPreferences", "chrome,modal,dialog,centerscreen,dependent");

}

function openWysHistory ()
{

	if(!wyspref_histenbled){alert("Feature Disabled!\n Please Change Preferences for wySUwyg"); return;}
	//else
	var histtab="chrome://wysuwyg/content/wysuwyg_history.xul";	
	//gBrowser.selectedTab=gBrowser.addTab(histtab);
	
	//var e_par = "toolbar=no,menubar=no,personalbar=no,width=500,height=300, alwaysRaised=no," 
	//			+"centerscreen=yes ,scrollbars=no,resizable=yes, dependent=no,chrome=no, modal=no" ;	
	var e_win = window.openDialog(histtab, "wys_hist", "resizable=yes,chrome,centerscreen=yes,width=500,height=300");	
	if (e_win==null){alert('Sorry! Editor window could not be launched.\nAre you using a pop-up blocker?');return;}
	
	
}


function openWysHelp ()
{
	try{
	  gBrowser.selectedTab=gBrowser.addTab(wysHelpURL);
	}
	catch (e){alert("Could not load Online Help from \n"+ wysHelpURL);}
	

}

function openWysFontlist()
{
	var fontwin="chrome://wysuwyg/content/wysuwyg_fontlistDialog.xul";
	window.openDialog(fontwin, "wySUwygFonts", "chrome,dialog,centerscreen,dependent");

}

function loadPrefs()
{
	 try{
 		var prefs = Components.classes["@mozilla.org/preferences-service;1"].
                getService(Components.interfaces.nsIPrefBranch);   
        
      wyspref_tabenabled = prefs.getBoolPref("wysuwyg.newfeatures.tabenabled");   
	  wyspref_sdbarenabled = prefs.getBoolPref("wysuwyg.newfeatures.sidebarenabled");   
	  wyspref_histenbled = prefs.getBoolPref("wysuwyg.newfeatures.histenabled");   
	  wyspref_winontop = prefs.getBoolPref("wysuwyg.newfeatures.winontop");   
	  wyspref_referenabled = prefs.getBoolPref("wysuwyg.newfeatures.referenabled");
	  wyspref_debugenabled = prefs.getBoolPref("wysuwyg.newfeatures.debugenabled"); 
	  
	  
	  	
    
	}catch (ex) {/* Browser/Window startup, Die Silently */}
}





//document.addEventListener("WYS_ExtTalkEvent", this.myTabListener, false, true);
window.addEventListener("load", WYS_Olay.initOverlay, false);
window.addEventListener("unload", WYS_Olay.cleanOverlay, false);


