/*---------------------------------------
 A Plugin for Xinha to resize box elements
 Developed for the wySUwyg extension for Firefox ( http://wysuwyg.mozdev.org )
 -----------------------------------------
 author: Rahul Singh
 e-mail: induscrypt@gmail.com
 

---------------------------------------*/

function IndusResize(editor) {
	this.editor = editor;	
  var cfg = editor.config;
  var self = this;
 

  cfg.registerButton({
	id       : "indusresize",
	tooltip  :  this._lc("Resize this box"),
	image    : editor.imgURL("resize.png", "IndusResize"), 
	textMode : false,
  action   : function(editor) { 
               self.buttonPress(editor); 
             }
  });
  cfg.addToolbarElement("indusresize", "htmlmode", 1);  
}


IndusResize.prototype.buttonPress = function(editor) { 
	var self = this;
	var param = new Object();
	var prenode= null;
	param.editor = editor;	
		
	//search for the first block level ancestor
	var ancs=editor.getAllAncestors();
	for (i=0; i<ancs.length;i++)
	{
		var tag=ancs[i].tagName;
		//alert('|'+tag+'|');
		var tmp=tag.match(/(^pre$)|(^div$)|(^b$)|(^center$)/i);
		if (tmp !=null){prenode=ancs[i]; break;}
	
	}
	
	if (prenode==null){alert(HTMLArea._lc('cursor is not inside a box!')); return;}		
	//else
		var c=confirm('Resize '+ prenode.tagName +' box?');
		if(c) 
		{	param.cnode=prenode;	
			self.openPop(editor,param,prenode);		
		}
		return; 		
};





//pops up the dialogs, gets the returned values,  
//args: editor, params,slection,node to change 
IndusResize.prototype.openPop = function(editor, param,cnode) 
{
	
//popup 
	editor._popupDialog ( "plugin://IndusResize/indus-resize", 
		function( obj ) 
		{//on return, do this
    		if ( !obj ) 
    		{//user must have pressed Cancel
     		 return false;
     		}
     		 else return true; //return values are not needed here
		}, param );
  
};	



IndusResize._pluginInfo = {
name          : "IndusResize",
version       : "1.0",
developer     : "Rahul Singh",
developer_url : "mailto:induscrypt@gmail.com",
c_owner       : "Rahul Singh",
sponsor       : "Independent production",
sponsor_url   : "http://wysuwyg.mozdev.org",
license       : "htmlArea"
};

IndusResize.prototype._lc = function(string) {	
	
    return HTMLArea._lc(string, 'IndusResize');   
   
   };
   
   
  
	
